VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frm1 
   AutoRedraw      =   -1  'True
   Caption         =   "ICS VISA VXI-11.3 Demo Form"
   ClientHeight    =   8070
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9870
   FontTransparent =   0   'False
   Icon            =   "VISA_VXI11_3_Demo.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   10892.3
   ScaleMode       =   0  'User
   ScaleWidth      =   15263.2
   StartUpPosition =   3  'Windows Default
   WhatsThisHelp   =   -1  'True
   Begin MSComDlg.CommonDialog cdbHelp 
      Left            =   6600
      Top             =   1080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      FileName        =   "GPIBkybd2.htm"
      HelpFile        =   "GPIBkybd2.htm"
   End
   Begin VB.Frame frmCmdLp 
      Caption         =   "Device Command Loop"
      Height          =   735
      Left            =   240
      TabIndex        =   24
      Top             =   7200
      Width           =   3135
      Begin VB.CommandButton cmdCmdtstoff 
         Caption         =   "Stop Loop"
         Height          =   375
         Left            =   1800
         TabIndex        =   26
         ToolTipText     =   "Stops Device Command loop"
         Top             =   240
         Width           =   1095
      End
      Begin VB.CommandButton cmdCmdtst 
         Caption         =   "Start Loop"
         Height          =   375
         Left            =   360
         TabIndex        =   25
         ToolTipText     =   "Starts loop using text inthe Device Command box"
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.TextBox txtRev 
      BackColor       =   &H8000000B&
      BorderStyle     =   0  'None
      Height          =   240
      Left            =   5160
      TabIndex        =   20
      Top             =   7680
      Width           =   2055
   End
   Begin VB.TextBox txtError 
      Height          =   375
      Left            =   240
      TabIndex        =   15
      Top             =   480
      Visible         =   0   'False
      Width           =   9255
   End
   Begin VB.Frame frmResults 
      Caption         =   "Device Response"
      Height          =   2175
      Left            =   240
      TabIndex        =   12
      Top             =   4080
      Width           =   5895
      Begin VB.CheckBox ckDispAll 
         Caption         =   "Display All Characters"
         Height          =   255
         Left            =   240
         TabIndex        =   28
         ToolTipText     =   "Shows non-printing characters"
         Top             =   720
         Width           =   2415
      End
      Begin VB.CheckBox ckByteCnt 
         Caption         =   "Display Byte Count"
         Height          =   255
         Left            =   240
         TabIndex        =   19
         ToolTipText     =   "Displays input byte count"
         Top             =   480
         Width           =   2295
      End
      Begin VB.CheckBox ckAutoQuery 
         Caption         =   "Auto Query"
         Height          =   240
         Left            =   240
         TabIndex        =   18
         ToolTipText     =   "Reads a response to any query with a '?' in the command string"
         Top             =   255
         Width           =   1815
      End
      Begin VB.CommandButton cmdRead 
         Caption         =   "Read Device Response"
         Height          =   375
         Left            =   3120
         TabIndex        =   14
         ToolTipText     =   "Reads device data"
         Top             =   240
         Width           =   2535
      End
      Begin VB.TextBox txtResults 
         Height          =   975
         Left            =   240
         MultiLine       =   -1  'True
         TabIndex        =   13
         ToolTipText     =   "Displays command and device responses."
         Top             =   1080
         Width           =   5415
      End
   End
   Begin VB.Frame frmTerm 
      Caption         =   "Message Terminators"
      Height          =   615
      Left            =   240
      TabIndex        =   11
      Top             =   2520
      Width           =   2895
      Begin VB.CheckBox ckLF 
         Caption         =   "LF"
         Height          =   255
         Left            =   1800
         TabIndex        =   17
         ToolTipText     =   "Adds linefeed terminator to command string"
         Top             =   240
         Value           =   1  'Checked
         Width           =   615
      End
      Begin VB.CheckBox ckCR 
         Caption         =   "CR"
         Height          =   255
         Left            =   240
         TabIndex        =   16
         ToolTipText     =   "Adds CR terminator  to command string"
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.Frame frmCMD 
      Caption         =   "Device Command"
      Height          =   735
      Left            =   240
      TabIndex        =   9
      Top             =   3240
      Width           =   5895
      Begin VB.ComboBox combCmd 
         Height          =   315
         ItemData        =   "VISA_VXI11_3_Demo.frx":57E2
         Left            =   240
         List            =   "VISA_VXI11_3_Demo.frx":57E4
         TabIndex        =   27
         ToolTipText     =   "Enter device specific commands - ASCII characters only"
         Top             =   240
         Width           =   4455
      End
      Begin VB.CommandButton cmdSend 
         Caption         =   "Send"
         Height          =   375
         Left            =   4920
         TabIndex        =   10
         ToolTipText     =   "Sends text in then Device Command String box"
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.Frame frm488_2 
      Caption         =   "Instrument Commands"
      Height          =   2895
      Left            =   7560
      TabIndex        =   7
      Top             =   3360
      Width           =   1935
      Begin VB.CheckBox ckAutoLock 
         Caption         =   "Auto Lock"
         Height          =   255
         Left            =   240
         TabIndex        =   32
         Top             =   360
         Width           =   1335
      End
      Begin VB.CommandButton cmdSDC 
         Caption         =   "Device Clear"
         Height          =   375
         Left            =   240
         TabIndex        =   23
         ToolTipText     =   "Sends Device Clear (SDC) message to the device"
         Top             =   1800
         Width           =   1400
      End
      Begin VB.CommandButton cmdUnlock 
         Caption         =   "Unlock"
         Height          =   375
         Left            =   240
         TabIndex        =   22
         ToolTipText     =   "Removes the device lock"
         Top             =   1200
         Width           =   1400
      End
      Begin VB.CommandButton cmdLock 
         Caption         =   "Lock"
         Height          =   375
         Left            =   240
         TabIndex        =   21
         ToolTipText     =   "Locks VXI-11 access to tthe device to prevent others from using it."
         Top             =   720
         Width           =   1400
      End
      Begin VB.CommandButton cmdSpoll 
         Caption         =   "Serial Poll"
         Height          =   375
         Left            =   240
         TabIndex        =   8
         ToolTipText     =   "Serial Polls the device"
         Top             =   2280
         Width           =   1400
      End
   End
   Begin VB.TextBox txtCount 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   4440
      TabIndex        =   5
      Top             =   6840
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Timer Timer1 
      Left            =   3600
      Top             =   6480
   End
   Begin VB.CommandButton cmdIDNtstoff 
      Caption         =   "Stop Loop"
      Height          =   375
      Left            =   2040
      TabIndex        =   3
      ToolTipText     =   "Stops *IDN? query loop"
      Top             =   6600
      Width           =   1095
   End
   Begin VB.CommandButton cmdIDNtst 
      Caption         =   "Run Loop"
      Height          =   375
      Left            =   600
      TabIndex        =   2
      ToolTipText     =   "Starts *IDN? query loop"
      Top             =   6600
      Width           =   1215
   End
   Begin VB.Frame frmAddr 
      Caption         =   "Instrument Resource  Address"
      Height          =   1245
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   5895
      Begin VB.TextBox txtIPAddr 
         Height          =   285
         Left            =   840
         TabIndex        =   36
         ToolTipText     =   "Enter IP Address of the VXI-11.3 Instrument"
         Top             =   720
         Width           =   1815
      End
      Begin VB.CommandButton cmdLinki 
         Caption         =   "   Open Resource"
         Height          =   495
         Left            =   4560
         TabIndex        =   30
         ToolTipText     =   "Creates a VXI-11 link to an instrument (device)"
         Top             =   600
         Width           =   1095
      End
      Begin VB.ComboBox combInst 
         Height          =   315
         ItemData        =   "VISA_VXI11_3_Demo.frx":57E6
         Left            =   2880
         List            =   "VISA_VXI11_3_Demo.frx":57E8
         Sorted          =   -1  'True
         TabIndex        =   29
         ToolTipText     =   "Select inst number"
         Top             =   720
         Width           =   1455
      End
      Begin VB.Label lblAdr2 
         Caption         =   "Instrument IP Address             Inst number"
         Height          =   255
         Left            =   960
         TabIndex        =   35
         Top             =   360
         Width           =   3015
      End
      Begin VB.Label lblAddr1 
         Caption         =   "TCPIP::"
         Height          =   255
         Left            =   240
         TabIndex        =   34
         Top             =   720
         Width           =   615
      End
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   7800
      TabIndex        =   0
      ToolTipText     =   "Exits the program"
      Top             =   7560
      Width           =   1400
   End
   Begin VB.Frame frmIDNLoop 
      Caption         =   "IDN Message Loop"
      Height          =   735
      Left            =   240
      TabIndex        =   4
      Top             =   6360
      Width           =   3135
   End
   Begin VB.Label lblTitle 
      Caption         =   "ICS VISA Visual Basic Example for a VXI-11.3 Instrument -  ICS Model 8013"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   840
      TabIndex        =   37
      Top             =   120
      Width           =   7815
   End
   Begin VB.Label lbliLock 
      BackColor       =   &H000000FF&
      Caption         =   " Inst Link     Locked"
      Height          =   495
      Left            =   6600
      TabIndex        =   31
      Top             =   1680
      Width           =   735
   End
   Begin VB.Image ImageICS 
      Appearance      =   0  'Flat
      Height          =   765
      Left            =   7320
      Picture         =   "VISA_VXI11_3_Demo.frx":57EA
      Stretch         =   -1  'True
      Top             =   6480
      Width           =   2340
   End
   Begin VB.Label lblCount 
      Caption         =   "Loop Count"
      Height          =   255
      Left            =   4440
      TabIndex        =   6
      Top             =   6480
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Label lblKeepAliveMsg 
      BackColor       =   &H80000001&
      Caption         =   " Keeplive      Sent"
      Height          =   495
      Left            =   6600
      TabIndex        =   33
      Top             =   2520
      Visible         =   0   'False
      Width           =   735
   End
End
Attribute VB_Name = "frm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 '***************************************************************************
'   Visual Basic VISA Demo Program                                   11-30-06
'   Copyright 2006 ICS Electronics div Systems West, Inc.
'
'   Program uses VISA calls to control VXI-11.3 Instruments
'   Timer1 used for *IDN? and Device Command string loops
' ***************************************************************************
'   Project Changes
' ***************************************************************************

'Option Explicit
'Agilent VISA declarations
Dim defrm As Long             'Session to Default Resource Manager
Dim vi As Long                'Session to instrument
Dim strRes As String * 200    'Fixed length string to hold results
Dim strVisaErr As String * 200
'Program declarations
Dim CmdStr As String
Dim SPACE80S As String
Public udlink&                 'from create inst link
Public NL
Public Sendlock                'Send locked device flag
Public MsgSentFlg              'set by cmdSend, reset by Timer2
Public Device                  'instn
Public term%
Public IDNTestFlg
Public CMDloopFlg
Public LpCount

Private Sub ckAutoLock_Click()
    If ckAutoLock.Value = 1 Then
        If Sendlock = 1 Then                    'test for existing lock
            ckAutoLock.Value = 0
        Else
            cmdLock.Enabled = False
            cmdUnlock.Enabled = False
        End If
    Else
        cmdLock.Enabled = True
        cmdUnlock.Enabled = True
    End If
End Sub

Private Sub ckCR_Click()
    If ckCR.Value = 1 Then
       term% = 13                                   'set termination for CR or EOI
    End If
End Sub

Private Sub ckLF_Click()
    If ckLF.Value = 1 Then
       term% = 10                                   'set termination for LF or EOI
    End If
End Sub

Private Sub cmdLinki_Click()
    txtError.Visible = False
    cmdSend.Enabled = False
    cmdRead.Enabled = False
    cmdIDNtst.Enabled = False
    cmdIDNtstoff.Enabled = False
    cmdCmdtst.Enabled = False
    cmdCmdtstoff.Enabled = False
    cmdLock.Enabled = False
    cmdUnlock.Enabled = False
    cmdSDC.Enabled = False
    cmdSpoll.Enabled = False
    ckCR.Enabled = False
    ckLF.Enabled = False
    ckAutoLock.Enabled = False
    ckAutoQuery.Enabled = False
    ckByteCnt.Enabled = False
    combCmd.Text = ""
    If udlink& <> 0 Then                          'disable any prior device link
        Call viClose(Device)
        lbliLock.Visible = False
        udlink& = 0
    End If
    Device = combInst.Text
    ip$ = txtIPAddr.Text
    CmdStr$ = "TCPIP::" + ip$ + "::" + Device + "::INSTR"
    status = viOpen(defrm, CmdStr$, 0, 0, dev)      'open instrument resource
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    
    udlink& = dev                                       'udlink refers to the GPIB device
    txtResults.Text = "Link created to instrument at " & Device
    cmdSend.Enabled = True         'enable controls
    cmdRead.Enabled = True
    cmdIDNtst.Enabled = True
    cmdIDNtstoff.Enabled = False
    cmdCmdtst.Enabled = True
    cmdCmdtstoff.Enabled = False
    cmdLock.Enabled = True
    cmdUnlock.Enabled = True
    cmdSDC.Enabled = True
    cmdSpoll.Enabled = True
    ckCR.Enabled = True
    ckLF.Enabled = True
    ckAutoLock.Enabled = True
    ckCR.Value = 0
    ckLF.Value = 1
    ckAutoLock.Value = 0
    ckAutoQuery.Enabled = True
    ckByteCnt.Enabled = True
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    GoTo Linkiexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
Linkiexit:
End Sub

Private Sub cmdLock_Click()
    lockType& = VI_EXCLUSIVE_LOCK
    locktimeout& = 30000                    '30 seconds
    requestedKey$ = VI_NULL
    accessKey$ = VI_NULL
    status = viLock&(udlink&, lockType&, locktimeout&, requestedKey$, accessKey$)
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    
    txtError.Visible = False
    txtResults.Text = "Device " & Device & " locked"
    lbliLock.Visible = True
    lbliLock.Refresh
    Sendlock = 1                    'sets locked flag
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    GoTo lockexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
lockexit:
End Sub

Private Sub cmdSDC_Click()
    txtError.Visible = False
    combCmd.Text = ""
    txtResults.Text = ""

    status = viClear(udlink&)
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    
    txtError.Visible = False
    txtResults.Text = "Device Clear sent to device " & Device
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    GoTo SDCexit:
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
SDCexit:
End Sub

Private Sub cmdUnlock_Click()
    status = viUnlock(udlink&)
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    
    txtError.Visible = False
    txtResults.Text = "Device " & Device & " unlocked"
    lbliLock.Visible = False
    Sendlock = 0                    'clears locked flag
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    GoTo unlockexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
unlockexit:
End Sub

Private Sub combInst_Change()
    cmdLinki.Enabled = True
End Sub

Private Sub Tdelay(delaytime)
   starttime = Timer
   Do Until Timer >= starttime + delaytime
   Loop
End Sub

Private Sub cmdCmdtst_Click()
        If combCmd.Text = "" Then
            Beep
            txtResults.Text = "No command specified.  Enter a command before starting the Command Loop"
        Else
            CMDloopFlg = 1
            Timer1.Interval = 250
            cmdCmdtst.Enabled = False
            cmdCmdtstoff.Enabled = True
        End If
End Sub

Private Sub cmdCMDtstoff_Click()
    CMDloopFlg = 0
    cmdCmdtst.Enabled = True
    cmdCmdtstoff.Enabled = False
    If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
        txtCount.Visible = False
        lblCount.Visible = False
        LpCount = 0
        Timer1.Interval = 0                 'turn timer off
    End If
    
End Sub

Private Sub cmdExit_Click()
    If udlink& <> 0 Then                'close device session
        Call viClose(udlink&)
        lbliLock.Visible = False
        udlink& = 0
    End If
    Call viClose(defrm)                 'close main VISA session
    End
End Sub

Private Sub cmdIDNtst_Click()
        combCmd.Text = "*idn?"
        Timer1.Interval = 250
        IDNTestFlg = 1
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = True
End Sub

Private Sub cmdIDNtstoff_Click()
    IDNTestFlg = 0
    cmdIDNtst.Enabled = True
    cmdIDNtstoff.Enabled = False
    If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
        txtCount.Visible = False
        lblCount.Visible = False
        LpCount = 0
        Timer1.Interval = 0
    End If
End Sub

Private Sub cmdRead_Click()
    txtError.Visible = False
    If ckAutoLock.Value = 1 And Sendlock = 0 Then Call cmdLock_Click
    Sendlock = 0                                    'reset Sendlock flag
    Flags& = 0
    Instring$ = SPACE80S                            '100 spaces
    InCount& = Len(Instring$)
    bufSize& = Len(Instring$)
    If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
        txtResults.Text = "Device Read: Waiting for device response"
        txtResults.Refresh
    End If

    status = viRead(udlink&, Instring$, bufSize&, InCount&)
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    If ckAutoLock.Value = 1 Then
        Call cmdUnlock_Click
    End If
    If ckDispAll.Value = 0 Then
        L = InStr(Instring$, Chr$(13))              'check for CR
        If L <> 0 Then
            Instring$ = Left$(Instring$, L - 1)
        Else
            L = InStr(Instring$, Chr$(10))          'check for LF
            If L <> 0 Then
                Instring$ = Left$(Instring$, L - 1)
            End If
        End If
    End If
    txtError.Visible = False
    txtResults.Text = RTrim$(Instring$)
    If ckByteCnt.Value = 1 Then
        txtResults.Text = txtResults.Text + NL + "Byte count= " + Str$(InCount&)
    End If
    GoTo Readexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
Readexit:
End Sub

Private Sub cmdSend_Click()                                 'send command string
    txtError.Visible = False
    If ckAutoLock.Value = 1 Then Call cmdLock_Click
    Sendlock = 1                    'set Sendlock flag for read routine
    Outstring$ = combCmd.Text
    If Outstring$ = "" Then
        txtResults.Text = "Device command box empty, nothing sent to the device"
        Beep
        GoTo Sendexit:
    End If
    
    If ckCR = 1 Then Outstring$ = Outstring$ & Chr$(13)
    If ckLF = 1 Then Outstring$ = Outstring$ & Chr$(10)
    bufSize& = Len(Outstring$)
    status = viWrite(udlink&, Outstring$, bufSize&, outcount&)
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    
    txtError.Visible = False
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    If (ckAutoQuery.Value = 1) And (InStr(Outstring$, "?") <> 0) Then
        Call cmdRead_Click
    Else
        txtResults.Text = "Send String => " + Outstring$
        If ckAutoLock.Value = 1 Then Call cmdUnlock_Click
        Sendlock = 0                    'reset flag
    End If
    GoTo Sendexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
Sendexit:
End Sub

Private Sub cmdSPoll_Click()
    Dim STBbyte%
    txtError.Visible = False
    txtResults.Text = ""
    status = viReadSTB(udlink&, STBbyte%)    'queries instn status byte
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    
    txtResults.Text = "Serial poll response => " + Str$(STBbyte%)
    MsgSentFlg = 1                  'sets flag to show that the link was exercized
    GoTo Spollexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
Spollexit:
End Sub

Private Sub Form_Load()
    ' Open the default resource manager session
    'Call viOpenDefaultRM(defrm)
    status = viOpenDefaultRM(defrm)                 'open VISA session
    If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
    vi = vi                                          'initialize controls
    Rev$ = "Revised 11-30-2006"
    cmdLinki.Enabled = True
    cmdSend.Enabled = False
    cmdRead.Enabled = False
    cmdIDNtst.Enabled = False
    cmdIDNtstoff.Enabled = False
    cmdCmdtst.Enabled = False
    cmdCmdtstoff.Enabled = False
    cmdSDC.Enabled = False
    cmdSpoll.Enabled = False
    cmdLock.Enabled = False
    cmdUnlock.Enabled = False
    cmdExit.Enabled = True
    ckAutoLock.Enabled = False
    ckCR.Enabled = False
    ckLF.Enabled = False
    ckAutoQuery.Value = 1
    ckByteCnt.Value = 0
    lbliLock.Visible = False
    lblKeepAliveMsg.Visible = False
    SPACE80S = Space$(100)                          '100 spaces
    NL = Chr(13) + Chr(10)
    txtRev.Text = Rev$
    txtError.Text = ""                              'clear label and text box
    txtResults.Text = ""
    combCmd.Text = ""
    Device = ""
    IDNTestFlg = 0
    CMDloopFlg = 0
    txtCount.Visible = False
    LpCount = 0
    Timer1.Interval = 0
    txtResults.Enabled = True
    txtError.Enabled = False
    ErrFlag = 0
    IDNTestFlg = 0
    txtIPAddr.Text = "192.168.0.254"
    combInst.AddItem "inst0", 0
    combInst.AddItem "inst1", 1
    combInst.ListIndex = 0
    combCmd.AddItem "*esr?", 0
    combCmd.AddItem "*idn?", 1
    combCmd.AddItem "*stb?", 2
    Exit Sub
    
VisaErrorHandler:
   Call viStatusDesc(defrm, status, strVisaErr)
   txtError.Text = "*** Error : " + strVisaErr + vbExclamation + "VISA Error Message"
   txtError.Visible = True
   Exit Sub
End Sub

Private Sub Timer1_Timer()
    If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
        'txtCount.Visible = False
        'LpCount = 0
        GoTo Timerexit:
    End If
    
    If IDNTestFlg = 1 Then
        If ckAutoLock.Value = 1 Then
            Call cmdLock_Click
            Sendlock = 1                    'set Sendlock flag for read routine
        End If
        Outstring$ = "*IDN?"
        If ckCR = 1 Then Outstring$ = Outstring$ + Chr$(13)
        If ckLF = 1 Then Outstring$ = Outstring$ + Chr$(10)
        bufSize& = Len(Outstring$)

        status = viWrite(udlink&, Outstring$, bufSize&, outcount&)
        If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
        
        txtError.Visible = False
        MsgSentFlg = 1                  'sets flag to show that the link was exercized
        If (ckAutoQuery.Value = 1) And (InStr(Outstring$, "?") <> 0) Then
            txtError.Text = "Read error" & NL & Error$ & " - Retry"
            Call cmdRead_Click
        End If
    End If
    
    If CMDloopFlg = 1 Then                                       'loop using the string in the combCmd.text
        If combCmd.Text = "" Then
            Beep
            txtError.Text = "Command box empty"
            txtError.Visible = True
        Else
            If ckAutoLock.Value = 1 Then
                Call cmdLock_Click
                Sendlock = 1                    'set Sendlock flag for read routine
            End If
            txtError.Visible = False
            Outstring$ = combCmd.Text
            If ckCR = 1 Then Outstring$ = Outstring$ + Chr$(13)
            If ckLF = 1 Then Outstring$ = Outstring$ + Chr$(10)
            bufSize& = Len(Outstring$)

            status = viWrite(udlink&, Outstring$, bufSize&, outcount&)
            If (status < VI_SUCCESS) Then GoTo VisaErrorHandler
            
            MsgSentFlg = 1                  'sets flag to show that the link was exercized
            If (ckAutoQuery.Value = 1) And (InStr(Outstring$, "?") <> 0) Then
                txtError.Text = "Read error" & NL & Error$ & " - Retry"
                Call cmdRead_Click
            End If
        End If
    End If
    
Timerexit1:       txtCount.Visible = True
    lblCount.Visible = True
    LpCount = LpCount + 1
    txtCount.Text = LpCount
    GoTo Timerexit:
    
VisaErrorHandler:
    Call viStatusDesc(defrm, status, strVisaErr)
    txtError.Text = "*** VISA Error : " + strVisaErr + Str$(vbExclamation)
    txtError.Visible = True
    Beep
    If ckAutoLock.Value = 1 Then Call cmdUnlock_Click
    Sendlock = 0                    'reset flag
    IDNTestFlg = 0
    CMDloopFlg = 0
Timerexit:
End Sub

Private Sub txtAddr_Change()
    cmdSet.Enabled = True
End Sub

Private Sub combCmd_KeyPress(KeyAscii As Integer)
    If KeyAscii = (13) Then
        Call cmdSend_Click
    End If
End Sub


